// 
// File:   ants.cc
// Author: cteam064
//
// Created on October 27, 2012, 10:47 AM
//

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
using namespace std;

class Ant
{
    public:
        int dir;
        int start;
        int pos;
};
//
// 
//

int Compare(const Ant *a, const Ant *b)
{
    return  a->start - b->start;
}

int Compute(Ant *ants,int len, int forest,int &P,int &Q)
{
    if(len == 1)
    {
        P = Q = ants[0].start;
        if(ants[0].dir>0)
            return len - ants[0].pos;
        else
            return ants[0].pos;
    }
    
    int time = 0;
    qsort(ants,len,sizeof(Ant),(int(*)(const void *, const void *))Compare);
    
    int start = 0;
    int end = len;
    P = 0;
    Q = 0;
    
    while(start<end)
    {    
        for(int i=start;i<end-1;i++)
        {
            if(ants[i].pos == ants[i+1].pos)
            {
              ants[i].pos*=-1;
              ants[i+1].pos*=-1;
            }
            if (ants[i].pos + 1 == ants[i+1].pos && ants[i].dir != ants[i+1].dir)
            {
              ants[i].pos*=-1;
              ants[i+1].pos*=-1;
            }
            if (ants[i].pos - 1 == ants[i+1].pos && ants[i].dir != ants[i+1].dir)
            {
              ants[i].pos*=-1;
              ants[i+1].pos*=-1;
            }
            
            ants[i].pos+=ants[i].dir;
            
            if (ants[i].pos < 0)
            {
                start++;
            }
        }
        ants[end-1].pos+=ants[end-1].dir;
        if (ants[end-1].pos > forest)
            {
                end--;
            }
        time++;
    }
    
    
    return time-1;
}


int main(int argc, char** argv) {
    
    int len;
    int cnt;
    Ant * ants;
    char dir;
    int pos;
    int time;
    int p;
    int q;
    
    while(true)
    {
        if(scanf("%d %d",&len,&cnt)!=2)
            break;
        ants = new Ant[cnt];
        for(int i = 0;i<cnt;i++)
        {
            scanf("%d %c",&pos,&dir);
            if(dir == 'R')
                ants[i].dir = 1;
            else
                ants[i].dir = -1;
            ants[i].start = ants[i].pos = pos;
        }
        cout<<"Ants:"<<cnt<<endl;
        
        for(int i = 0;i < cnt;i++)
            cout<<"{start="<<ants[i].start<<",dir="<<ants[i].dir<<"}"<<endl;
        time = Compute(ants,cnt,len,p,q);
        cout<<"The last ant will fall down in "<<time<<" seconds - started at"<<ants[p].start;
        if(p!=q)
            cout<<" and "<<ants[q].start;
        cout<<endl;
        delete [] ants;
    }
    
    return 0;
}

